import { PostgrestBuilder, PostgrestQueryBuilder, PostgrestSingleResponse, PostgrestMaybeSingleResponse, PostgrestResponse } from '@supabase/postgrest-js';
import { GenericSchema, GenericTable } from '@supabase/postgrest-js/dist/module/types';

declare const getTable: (query: PostgrestBuilder<any> | PostgrestQueryBuilder<GenericSchema, GenericTable>) => string;

type AnyPostgrestResponse<Result> = PostgrestSingleResponse<Result> | PostgrestMaybeSingleResponse<Result> | PostgrestResponse<Result>;
declare const isAnyPostgrestResponse: <Result>(q: unknown) => q is AnyPostgrestResponse<Result>;
type PostgrestPaginationResponse<Result> = Result[];
declare const isPostgrestPaginationResponse: <Result>(q: unknown) => q is PostgrestPaginationResponse<Result>;
type PostgrestPaginationCacheData<Result> = Result[][];
declare const isPostgrestPaginationCacheData: <Result>(q: unknown) => q is PostgrestPaginationCacheData<Result>;
type PostgrestHasMorePaginationResponse<Result> = {
    data: Result[];
    hasMore: boolean;
};
declare const isPostgrestHasMorePaginationResponse: <Result>(q: unknown) => q is PostgrestHasMorePaginationResponse<Result>;
type PostgrestHasMorePaginationCacheData<Result> = PostgrestHasMorePaginationResponse<Result>[];
declare const isPostgrestHasMorePaginationCacheData: <Result>(q: unknown) => q is PostgrestHasMorePaginationCacheData<Result>;
declare const isPostgrestBuilder: <Result>(q: unknown) => q is PostgrestBuilder<Result>;
type QueryWithoutWildcard<QueryString extends string> = QueryString extends `${infer Any}*${infer Any}` ? 'Wildcard selector is not allowed' : QueryString;

export { AnyPostgrestResponse, PostgrestHasMorePaginationCacheData, PostgrestHasMorePaginationResponse, PostgrestPaginationCacheData, PostgrestPaginationResponse, QueryWithoutWildcard, getTable, isAnyPostgrestResponse, isPostgrestBuilder, isPostgrestHasMorePaginationCacheData, isPostgrestHasMorePaginationResponse, isPostgrestPaginationCacheData, isPostgrestPaginationResponse };
