// src/get-table.ts
var getTable = (query) => query["url"].pathname.split("/").pop();

// src/types.ts
var isAnyPostgrestResponse = (q) => {
  if (!q)
    return false;
  return typeof q.data === "object" || Array.isArray(q.data);
};
var isPostgrestPaginationResponse = (q) => {
  return Array.isArray(q);
};
var isPostgrestPaginationCacheData = (q) => {
  if (!Array.isArray(q))
    return false;
  return q.length === 0 || Array.isArray(q[0]);
};
var isPostgrestHasMorePaginationResponse = (q) => {
  if (!q)
    return false;
  return Array.isArray(q.data) && typeof q.hasMore === "boolean";
};
var isPostgrestHasMorePaginationCacheData = (q) => {
  if (!Array.isArray(q))
    return false;
  if (q.length === 0)
    return true;
  const firstPage = q[0];
  return Array.isArray(
    firstPage.data
  ) && typeof firstPage.hasMore === "boolean";
};
var isPostgrestBuilder = (q) => {
  return typeof q.throwOnError === "function";
};
export {
  getTable,
  isAnyPostgrestResponse,
  isPostgrestBuilder,
  isPostgrestHasMorePaginationCacheData,
  isPostgrestHasMorePaginationResponse,
  isPostgrestPaginationCacheData,
  isPostgrestPaginationResponse
};
//# sourceMappingURL=index.mjs.map